
#include <iostm8s103k3.h>
#include <intrinsics.h>
#include <stdio.h>
#include "UART.h"
//----------------------------
#define LED1 6 //the LED on the PB6
#define LED2 3 //the LED on the PD2
#define LED3 7 //the LED on the PD7

#define LED1_ON  PB_ODR |=  (1<<LED1)
#define LED1_OFF PB_ODR &= ~(1<<LED1)

#define LED2_ON  PD_ODR |=  (1<<LED2)
#define LED2_OFF PD_ODR &= ~(1<<LED2)

#define LED3_ON  PD_ODR |=  (1<<LED3)
#define LED3_OFF PD_ODR &= ~(1<<LED3)

int i=0,j=0,k=0;
unsigned int cnt=0,cnt1=0,cnt4=0;

//------------------------
void InitialiseSystemClock(void);
void GPIO_Init(void);
void TIM1_Init (void);
void TIM2_Init (void);
void TIM4_Init (void);
void Delay (unsigned int Time);
//------------------------
#pragma vector = TIM1_OVR_UIF_vector
__interrupt void TIM1_UPD_OVF_IRQHandler(void)
{
     //PD_ODR_ODR3 = !PD_ODR_ODR3;     //  Toggle Port D, pin 3.
  if(++cnt1>1000){
    cnt1=0;
        if(i==0){
        LED1_ON; // turn on LEDs
	UART1_SendString ("\n\rLED1&2->ON");
        i=1;
     }
     else
     {
        LED1_OFF;// turn off LEDs
        UART1_SendString ("\n\rLED1&2->OFF");
        i=0;
     }
    
  }
  

     TIM1_SR1_UIF = 0;  // Update interrupt flag
}

//----------------------------
#pragma vector = TIM2_OVR_UIF_vector
__interrupt void TIM2_UPD_OVF_IRQHandler(void)
{
     //PD_ODR_ODR3 = !PD_ODR_ODR3;     //  Toggle Port D, pin 3.
  


    
if(++cnt>1000)
{
  cnt=0;
      if(j==0){
        LED2_ON; // turn on LEDs
//	UART1_SendString ("\n\rLED1ON");
        j=1;
     }
     else
     {
        LED2_OFF;// turn off LEDs
//        UART1_SendString ("\n\rLED1OFF");
        j=0;
     } 
  
}
     TIM2_SR1_UIF = 0;  // Update interrupt flag
}
//----------------------------

#pragma vector = TIM4_OVR_UIF_vector
__interrupt void TIM4_UPD_OVF_IRQHandler(void)
{
     //PD_ODR_ODR3 = !PD_ODR_ODR3;     //  Toggle Port D, pin 3. 
if(++cnt4>5000)
{
  cnt4=0;
      if(k==0){
        LED3_ON; // turn on LEDs
//	UART1_SendString ("\n\rLED1ON");
        k=1;
     }
     else
     {
        LED3_OFF;// turn off LEDs
//        UART1_SendString ("\n\rLED1OFF");
        k=0;
     } 
  
}
     TIM4_SR_UIF = 0;  // Update interrupt flag
}
//----------------------------
int main( void )
{
  
   __disable_interrupt();
   InitialiseSystemClock();
   UART1_Init();
   TIM1_Init ();
   TIM2_Init ();
   TIM4_Init ();
   GPIO_Init();
   UART1_SendString("\n\rStart");
   UART1_SendString("\n\rTest Timer1&Timer2");

   __enable_interrupt();

   while (1)
    {	

    }
}

//------------------------------
void GPIO_Init()
{
  PB_DDR |= (1<<LED1); // 1: 1: Output mode
  PB_CR1 |= (1<<LED1); // 1: Push-pull
  PB_CR2 &=~(1<<LED1); // 0: Output speed up to 2 MHz
  
  PD_DDR |= (1<<LED2); //PD_DDR.DDR3 = 1; //1: 1: Output mode
  PD_CR1 |= (1<<LED2); //PD_CR1.C13 = 1; // 1: Push-pull
  PD_CR2 &=~(1<<LED2); //PD_CR1.C23 = 0; // 0: Output speed up to 2 MHz
  //PD_CR2 |=  (1<<LED1); // 1: Output speed up to 10 MHz
  
  PD_DDR |= (1<<LED3); // 1: 1: Output mode
  PD_CR1 |= (1<<LED3); // 1: Push-pull
  PD_CR2 &=~(1<<LED3); // 0: Output speed up to 2 MHz
}
//------------------------------
void InitialiseSystemClock(void)
{
   CLK_ICKR = 0;                       //  Reset the Internal Clock Register.
   CLK_ICKR_HSIEN = 1;                 //  Enable the HSI.
   CLK_ECKR = 0;                       //  Disable the external clock.
   while (CLK_ICKR_HSIRDY == 0);       //  Wait for the HSI to be ready for use.
   CLK_CKDIVR = 0;                     //  Ensure the clocks are running at full speed.
   CLK_PCKENR1 = 0xff;                 //  Enable all peripheral clocks.
   CLK_PCKENR2 = 0xff;                 //  Ditto.
   CLK_CCOR = 0;                       //  Turn off CCO.
   CLK_HSITRIMR = 0;                   //  Turn off any HSIU trimming.
   CLK_SWIMCCR = 0;                    //  Set SWIM to run at clock / 2.
   CLK_SWR = 0xe1;                     //  Use HSI as the clock source.
   CLK_SWCR = 0;                       //  Reset the clock switch control register.
   CLK_SWCR_SWEN = 1;                  //  Enable switching.
   while (CLK_SWCR_SWBSY != 0);        //  Pause while the clock switch is busy.
}

//----------------------------
void TIM1_Init (void) 
{
   TIM1_CR1_CEN = 0;  //  Timer disable

   TIM1_PSCRH = 15 / 256; //  16000000 / (psc + 1) = 16000000 / 160 = 1000Hz
   TIM1_PSCRL = 15 % 256; //  Prescaler .
   TIM1_ARRH = 1000 / 256;   // 
   TIM1_ARRL = 1000% 256;//1ms
   TIM1_CNTRH = 0x0000;           
   TIM1_CNTRL = 0x0000; 
   
   TIM1_IER_UIE = 1;  //  Enable the update interrupts.
   TIM1_CR1_ARPE = 1; // Auto-reload preload enable
   TIM1_CR1_CEN = 1;  //  Timer enable
}
//----------------------------
void TIM2_Init (void) 
{
   TIM2_CR1_CEN = 0;  //  Timer disable

   TIM2_PSCR = 4; //  16000000 / 2^(psc[3:0]) 1000000 Hz
   
   TIM2_ARRH = 1000 / 256;   // 
   TIM2_ARRL = 1000% 256;//1ms
   TIM2_CNTRH = 0x0000;           
   TIM2_CNTRL = 0x0000; 
   
   TIM2_IER_UIE = 1;  //  Enable the update interrupts.
   TIM2_CR1_ARPE = 1; // Auto-reload preload enable
   TIM2_CR1_CEN = 1;  //  Timer enable
}
//----------------------------
void TIM4_Init (void) 
{
   TIM4_CR1_CEN = 0;  //  Timer disable

   TIM4_PSCR = 4; //  16000000 / 2*(psc[2:0])= 2000000 Hz
   
   TIM4_ARR = 200;   // 

   TIM4_IER_UIE = 1;  //  Enable the update interrupts.
   TIM4_CR1_ARPE = 1; // Auto-reload preload enable
   TIM4_CR1_CEN = 1;  //  Timer enable
}
//----------------------------
void Delay (unsigned int Time)
{
    unsigned int i;
    
    i = 0;
    while (Time--) {
        for (i = 0; i < 2285; i++);
    }
}